# inf226 mand 2



This application is very simple and bare bones. you can send messages to others and receive messages. All extra features like time stamps extra functionality appearance and how well written this readme is, all came second to actually finishing the app. As for the design of the app, it largely isnt mine, most of it is copied from the login server project, where there already were functions to send and search, which have been modified to be more user friendly, for example search is never called by the user and only shows new messages for and from the user instead of every message. send is still relatively the same. I also spiced up the login part of the project and added a database of users with passwords. the passwords are hashed, but not salted, because i felt that if i just say that i know i should do it here, that would atleast be better than not delivering. 

the application is secured from sql injection per the methods showed in the login server project.
as for cross site request forgery attacks, the login page uses a csrf token to ensure the identity of the requester, the index page does not, but probably should have tokens aswell.
i cannot vouch for the secure design of the app, it is very simple and only offers one action to the user (sending messages), but maybe one or more of the libraries i used are exploitable, i would not know.

for testing of the app, first run the flask server with flask run, then go to localhost:5000 or whichever host and port you chose when starting the server. enter a username and password into the fields on the login page, then click register, then login. in the index page you can enter another users name, and the a message, and send the message to them, if you make another account with that name, and log in to the app, you should see the messages from the other account. This also updates in real time (which is really cool).

the apps main function, to send and display messages are implemented as such: the search function, sends a request to the server to get all the messages which are sent to or from the current logged in user and displays them on the screen using innerHTML, then it adds the id of every message gotten to a locally saved list, from then on it checks the list of messages it receives against the list it keeps, and only if it finds any messages whos id is not in the list, will it display them. as for sending, the message is entered into the text field, and the recipient is entered into the to field, javascript then gets these values, along with sender from a hidden field which is assigned as the page is loaded, and sends a send request to the server, the server adds the message to the database and the send function calls search to display the recent message immediately. the search function is continuosly called by setInterval to make the app continously update with new messages from the server. the login page has the user enter name and password into the fields, if login is clicked it is submitted and POSTed to the server, which checks the csrf token, and then checks the hashed password and username. If it validates, it sets the logged in session cookie and routes to the index page sending the username to html, which stores it in a hidden field. if register is clicked it checks if the username is in the database and if it isnt, stores it there, and puts a message on the screen telling the user if it was succesful or not.

Threat model (maybe??)
potential attackers are groups which take interest in private conversations between others, more specifically the potential attackers are everyone. As for the potential actions of an attacker, they could find a way to access the login database, in which case they could sit down with their sha256 decrypter and spend 2.72*10^54 days to crack a single password, or more lucratively they could hack into the messages database, and just look at the messages themselves. however this is pretty much impossible as well since theres no way to sql inject the search method, and that is the only time theres even a select queried on the database. theres also the potential that the attacker can just guess the password of a user, this would allow them to see all messages sent to and from that user, in addition to being able to make more messages posing as that user. this, being the only realistic attack (that i am aware of), poses a risk to confidentiality and integrity, there is no way to change username or password, so availability should remain unaffected for the victim. this could be protected better against, but i didnt prioritise time to work on password requirements, or somehow implement 2fa. the fact that once an attacker is in, they can read the messages of the user, is however unfixable, as that is also the entire purpose of the app.

the main attack vector of this app would have to be guessing a password, either through using a program or whatever other means. the server has no defense against many request so every password can easily be brute forced by having a machine input all possible passwords and just sending it to the server. really there hasnt been much done to protect against this attack, stronger passwords, 2fa, and some sort of limit on amounts of time one can try to log in would have been implemented had i both known how and had time. 

the access control model is actually implemented fairly well, given that the user is logged in to their own account, they can only send messages from themselves, and only read messages from themselves, or messages that were sent to them. the one potential flaw in this, is something i noticed in my own testing, which is that sometimes, the logged in session cookie doesnt get removed, which means that one may be accidentally logged in to the wrong account when loading the app, however i also "fixed" this accidentally by saving the username in the html, from the login function serverside, so if you ever access the page without logging in, it crashes and displays nothing. (which also kinda defeats the purpose of the logged in cookie but im not touching the code that works 7 hours before the deadline)

there is no logging involved, as i didnt see the point before now, however if i were to implement it, i would add another database to the project with the fields username and time, to serve as the log of login times of accounts, i would also put a time stamp on messages in the messages database and on users in the user database. 
